using System;
using System.Collections;
using System.Collections.Generic;
using System.Text;
using System.Threading;
using System.Linq;
using Crestron;
using Crestron.Logos.SplusLibrary;
using Crestron.Logos.SplusObjects;
using Crestron.SimplSharp;

namespace UserModule_EPISODE_EA_RSP_V1_2
{
    public class UserModuleClass_EPISODE_EA_RSP_V1_2 : SplusObject
    {
        static CCriticalSection g_criticalSection = new CCriticalSection();
        
        
        Crestron.Logos.SplusObjects.DigitalInput POWER_ON;
        Crestron.Logos.SplusObjects.DigitalInput POWER_OFF;
        InOutArray<Crestron.Logos.SplusObjects.DigitalInput> SELECT_OUTPUT;
        InOutArray<Crestron.Logos.SplusObjects.DigitalInput> SELECT_INPUT;
        InOutArray<Crestron.Logos.SplusObjects.DigitalInput> OUTPUT_VOLUME_UP;
        InOutArray<Crestron.Logos.SplusObjects.DigitalInput> OUTPUT_VOLUME_DOWN;
        InOutArray<Crestron.Logos.SplusObjects.DigitalInput> MUTE_OUTPUT;
        InOutArray<Crestron.Logos.SplusObjects.AnalogInput> SET_OUTPUT_VOLUME;
        Crestron.Logos.SplusObjects.DigitalOutput POWER_STATE;
        InOutArray<Crestron.Logos.SplusObjects.AnalogOutput> OUTPUT_SOURCE;
        InOutArray<Crestron.Logos.SplusObjects.AnalogOutput> OUTPUT_VOLUME;
        SplusTcpClient CLIENT;
        StringParameter IP_ADDRESS;
        StringParameter USERNAME;
        StringParameter PASSWORD;
        ushort G_SELECTED_OUTPUT = 0;
        ushort G_SELECTED_INPUT = 0;
        ushort [] G_OUTPUT_MUTE;
        short G_CONNECTIONSTATUS = 0;
        short G_SOCKETSTATUS = 0;
        private CrestronString MAKECMD (  SplusExecutionContext __context__, CrestronString TYPE , CrestronString JSON ) 
            { 
            CrestronString RESULT;
            RESULT  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 1024, this );
            
            
            __context__.SourceCodeLine = 151;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt ( Functions.Length( JSON ) < 1 ))  ) ) 
                { 
                __context__.SourceCodeLine = 152;
                MakeString ( RESULT , "{{\"type\":\"{0}\"}}", TYPE ) ; 
                } 
            
            else 
                { 
                __context__.SourceCodeLine = 154;
                MakeString ( RESULT , "{{\"type\":\"{0}\",{1}}}", TYPE , JSON ) ; 
                } 
            
            __context__.SourceCodeLine = 157;
            return ( RESULT ) ; 
            
            }
            
        private CrestronString MAKEKVPAIRNOQUOTES (  SplusExecutionContext __context__, CrestronString KEY , CrestronString VALUE ) 
            { 
            CrestronString RESULT;
            RESULT  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 512, this );
            
            
            __context__.SourceCodeLine = 164;
            MakeString ( RESULT , "\"{0}\":{1}", KEY , VALUE ) ; 
            __context__.SourceCodeLine = 166;
            return ( RESULT ) ; 
            
            }
            
        private CrestronString MAKEKVPAIR (  SplusExecutionContext __context__, CrestronString KEY , CrestronString VALUE ) 
            { 
            CrestronString QUOTEV;
            QUOTEV  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 512, this );
            
            
            __context__.SourceCodeLine = 173;
            MakeString ( QUOTEV , "\"{0}\"", VALUE ) ; 
            __context__.SourceCodeLine = 175;
            return ( MAKEKVPAIRNOQUOTES (  __context__ , KEY, QUOTEV) ) ; 
            
            }
            
        private CrestronString MAKEKVPAIRINT (  SplusExecutionContext __context__, CrestronString KEY , ushort VALUE ) 
            { 
            CrestronString RESULT;
            RESULT  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 512, this );
            
            
            __context__.SourceCodeLine = 182;
            MakeString ( RESULT , "\"{0}\":{1:d}", KEY , (short)VALUE) ; 
            __context__.SourceCodeLine = 184;
            return ( RESULT ) ; 
            
            }
            
        private ushort GETINT (  SplusExecutionContext __context__, CrestronString DATA , CrestronString VALUE ) 
            { 
            ushort IT = 0;
            
            CrestronString JUNK;
            JUNK  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 128, this );
            
            CrestronString COPY;
            COPY  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 1024, this );
            
            
            __context__.SourceCodeLine = 193;
            SetString ( DATA , (int)1, COPY ) ; 
            __context__.SourceCodeLine = 195;
            IT = (ushort) ( Functions.Find( VALUE , COPY ) ) ; 
            __context__.SourceCodeLine = 197;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt (IT == 0))  ) ) 
                {
                __context__.SourceCodeLine = 198;
                return (ushort)( Functions.ToInteger( -( 1 ) )) ; 
                }
            
            __context__.SourceCodeLine = 200;
            JUNK  .UpdateValue ( Functions.Remove ( VALUE , COPY )  ) ; 
            __context__.SourceCodeLine = 201;
            JUNK  .UpdateValue ( Functions.Remove ( ":" , COPY )  ) ; 
            __context__.SourceCodeLine = 203;
            IT = (ushort) ( Functions.Find( "," , COPY ) ) ; 
            __context__.SourceCodeLine = 205;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt ( IT > 0 ))  ) ) 
                { 
                __context__.SourceCodeLine = 206;
                return (ushort)( Functions.Atoi( Functions.Left( COPY , (int)( (IT - 1) ) ) )) ; 
                } 
            
            else 
                { 
                __context__.SourceCodeLine = 208;
                return (ushort)( Functions.Atoi( Functions.Left( COPY , (int)( (Functions.Length( COPY ) - 1) ) ) )) ; 
                } 
            
            
            return 0; // default return value (none specified in module)
            }
            
        private CrestronString GETVALUE (  SplusExecutionContext __context__, CrestronString DATA , CrestronString VALUE ) 
            { 
            ushort IT = 0;
            
            CrestronString JUNK;
            JUNK  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 128, this );
            
            CrestronString COPY;
            COPY  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 1024, this );
            
            
            __context__.SourceCodeLine = 218;
            SetString ( DATA , (int)1, COPY ) ; 
            __context__.SourceCodeLine = 220;
            IT = (ushort) ( Functions.Find( VALUE , COPY ) ) ; 
            __context__.SourceCodeLine = 222;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt (IT == 0))  ) ) 
                {
                __context__.SourceCodeLine = 223;
                return ( "" ) ; 
                }
            
            __context__.SourceCodeLine = 225;
            JUNK  .UpdateValue ( Functions.Remove ( VALUE , COPY )  ) ; 
            __context__.SourceCodeLine = 226;
            JUNK  .UpdateValue ( Functions.Remove ( ":" , COPY )  ) ; 
            __context__.SourceCodeLine = 227;
            IT = (ushort) ( Functions.GetC( COPY ) ) ; 
            __context__.SourceCodeLine = 229;
            IT = (ushort) ( Functions.Find( "\"" , COPY ) ) ; 
            __context__.SourceCodeLine = 231;
            return ( Functions.Left ( COPY ,  (int) ( (IT - 1) ) ) ) ; 
            
            }
            
        private CrestronString GETOBJECT (  SplusExecutionContext __context__, CrestronString DATA , CrestronString VALUE ) 
            { 
            ushort IT = 0;
            
            CrestronString START;
            START  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 2, this );
            
            CrestronString END;
            END  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 2, this );
            
            CrestronString JUNK;
            JUNK  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 128, this );
            
            CrestronString COPY;
            COPY  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 1024, this );
            
            
            __context__.SourceCodeLine = 242;
            SetString ( DATA , (int)1, COPY ) ; 
            __context__.SourceCodeLine = 244;
            IT = (ushort) ( Functions.Find( VALUE , COPY ) ) ; 
            __context__.SourceCodeLine = 246;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt (IT == 0))  ) ) 
                {
                __context__.SourceCodeLine = 247;
                return ( "" ) ; 
                }
            
            __context__.SourceCodeLine = 249;
            JUNK  .UpdateValue ( Functions.Remove ( VALUE , COPY )  ) ; 
            __context__.SourceCodeLine = 250;
            JUNK  .UpdateValue ( Functions.Remove ( ":" , COPY )  ) ; 
            __context__.SourceCodeLine = 253;
            MakeString ( START , "{0}", Functions.Left ( COPY ,  (int) ( 1 ) ) ) ; 
            __context__.SourceCodeLine = 256;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt (START == "{"))  ) ) 
                { 
                __context__.SourceCodeLine = 257;
                END  .UpdateValue ( "}"  ) ; 
                } 
            
            else 
                {
                __context__.SourceCodeLine = 258;
                if ( Functions.TestForTrue  ( ( Functions.BoolToInt (START == "["))  ) ) 
                    { 
                    __context__.SourceCodeLine = 259;
                    END  .UpdateValue ( "]"  ) ; 
                    } 
                
                else 
                    { 
                    __context__.SourceCodeLine = 261;
                    return ( "" ) ; 
                    } 
                
                }
            
            __context__.SourceCodeLine = 267;
            IT = (ushort) ( Functions.Find( END , COPY ) ) ; 
            __context__.SourceCodeLine = 269;
            while ( Functions.TestForTrue  ( ( Functions.BoolToInt ( (Functions.TestForTrue ( Functions.BoolToInt (Functions.Find( START , COPY , IT ) != 0) ) && Functions.TestForTrue ( Functions.BoolToInt ( IT > Functions.Find( START , COPY , IT ) ) )) ))  ) ) 
                { 
                __context__.SourceCodeLine = 271;
                IT = (ushort) ( Functions.Find( END , COPY , (IT + 1) ) ) ; 
                __context__.SourceCodeLine = 269;
                } 
            
            __context__.SourceCodeLine = 274;
            return ( Functions.Left ( COPY ,  (int) ( IT ) ) ) ; 
            
            }
            
        private ushort GETARRAYCOUNT (  SplusExecutionContext __context__, CrestronString ARRAY ) 
            { 
            ushort IT = 0;
            
            ushort COUNT = 0;
            
            
            __context__.SourceCodeLine = 285;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt (Functions.Left( ARRAY , (int)( 1 ) ) != "["))  ) ) 
                { 
                __context__.SourceCodeLine = 286;
                return (ushort)( Functions.ToInteger( -( 1 ) )) ; 
                } 
            
            else 
                {
                __context__.SourceCodeLine = 287;
                if ( Functions.TestForTrue  ( ( Functions.BoolToInt (Functions.Right( ARRAY , (int)( 1 ) ) != "]"))  ) ) 
                    { 
                    __context__.SourceCodeLine = 288;
                    return (ushort)( Functions.ToInteger( -( 1 ) )) ; 
                    } 
                
                }
            
            __context__.SourceCodeLine = 291;
            IT = (ushort) ( Functions.Find( "}," , ARRAY ) ) ; 
            __context__.SourceCodeLine = 293;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt (IT == 0))  ) ) 
                { 
                __context__.SourceCodeLine = 294;
                if ( Functions.TestForTrue  ( ( Functions.BoolToInt ( Functions.Length( ARRAY ) > 2 ))  ) ) 
                    {
                    __context__.SourceCodeLine = 295;
                    return (ushort)( 1) ; 
                    }
                
                else 
                    {
                    __context__.SourceCodeLine = 297;
                    return (ushort)( 0) ; 
                    }
                
                } 
            
            __context__.SourceCodeLine = 300;
            while ( Functions.TestForTrue  ( ( Functions.BoolToInt (IT != 0))  ) ) 
                { 
                __context__.SourceCodeLine = 301;
                COUNT = (ushort) ( (COUNT + 1) ) ; 
                __context__.SourceCodeLine = 302;
                IT = (ushort) ( Functions.Find( "}," , ARRAY , (IT + 2) ) ) ; 
                __context__.SourceCodeLine = 300;
                } 
            
            __context__.SourceCodeLine = 305;
            COUNT = (ushort) ( (COUNT + 1) ) ; 
            __context__.SourceCodeLine = 307;
            return (ushort)( COUNT) ; 
            
            }
            
        private CrestronString GETARRAYITEM (  SplusExecutionContext __context__, CrestronString ARRAY , ushort INDEX ) 
            { 
            ushort IT = 0;
            
            ushort COUNT = 0;
            
            ushort START = 0;
            
            
            __context__.SourceCodeLine = 317;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt ( INDEX > GETARRAYCOUNT( __context__ , ARRAY ) ))  ) ) 
                {
                __context__.SourceCodeLine = 318;
                return ( "" ) ; 
                }
            
            __context__.SourceCodeLine = 320;
            IT = (ushort) ( Functions.Find( "}," , ARRAY ) ) ; 
            __context__.SourceCodeLine = 323;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt (IT == 0))  ) ) 
                { 
                __context__.SourceCodeLine = 324;
                return ( Functions.Mid ( ARRAY ,  (int) ( 2 ) ,  (int) ( (Functions.Length( ARRAY ) - 2) ) ) ) ; 
                } 
            
            __context__.SourceCodeLine = 328;
            COUNT = (ushort) ( 1 ) ; 
            __context__.SourceCodeLine = 329;
            START = (ushort) ( 2 ) ; 
            __context__.SourceCodeLine = 331;
            while ( Functions.TestForTrue  ( ( Functions.BoolToInt ( COUNT < INDEX ))  ) ) 
                { 
                __context__.SourceCodeLine = 332;
                START = (ushort) ( (IT + 2) ) ; 
                __context__.SourceCodeLine = 333;
                COUNT = (ushort) ( (COUNT + 1) ) ; 
                __context__.SourceCodeLine = 334;
                IT = (ushort) ( Functions.Find( "}," , ARRAY , START ) ) ; 
                __context__.SourceCodeLine = 331;
                } 
            
            __context__.SourceCodeLine = 338;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt (IT == 0))  ) ) 
                { 
                __context__.SourceCodeLine = 339;
                IT = (ushort) ( Functions.Find( "}" , ARRAY , START ) ) ; 
                } 
            
            __context__.SourceCodeLine = 342;
            return ( Functions.Mid ( ARRAY ,  (int) ( START ) ,  (int) ( ((IT - START) + 1) ) ) ) ; 
            
            }
            
        private CrestronString GETSOCKETERROR (  SplusExecutionContext __context__, ushort ERROR ) 
            { 
            
            __context__.SourceCodeLine = 347;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt (ERROR == 0))  ) ) 
                {
                __context__.SourceCodeLine = 348;
                return ( "Not Connected" ) ; 
                }
            
            __context__.SourceCodeLine = 350;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt (ERROR == 1))  ) ) 
                {
                __context__.SourceCodeLine = 351;
                return ( "Waiting for Connection" ) ; 
                }
            
            __context__.SourceCodeLine = 353;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt (ERROR == 2))  ) ) 
                {
                __context__.SourceCodeLine = 354;
                return ( "Connected" ) ; 
                }
            
            __context__.SourceCodeLine = 356;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt (ERROR == 3))  ) ) 
                {
                __context__.SourceCodeLine = 357;
                return ( "Connection Failed" ) ; 
                }
            
            __context__.SourceCodeLine = 359;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt (ERROR == 4))  ) ) 
                {
                __context__.SourceCodeLine = 360;
                return ( "Connection Broken Remotely" ) ; 
                }
            
            __context__.SourceCodeLine = 362;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt (ERROR == 5))  ) ) 
                {
                __context__.SourceCodeLine = 363;
                return ( "Connection Broken Locally" ) ; 
                }
            
            __context__.SourceCodeLine = 365;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt (ERROR == 6))  ) ) 
                {
                __context__.SourceCodeLine = 366;
                return ( "Performing DNS Lookup" ) ; 
                }
            
            __context__.SourceCodeLine = 368;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt (ERROR == 7))  ) ) 
                {
                __context__.SourceCodeLine = 369;
                return ( "DNS Lookup Failed" ) ; 
                }
            
            __context__.SourceCodeLine = 371;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt (ERROR == 8))  ) ) 
                {
                __context__.SourceCodeLine = 372;
                return ( "DNS Name Resolved" ) ; 
                }
            
            __context__.SourceCodeLine = 374;
            return ( "Unknown error" ) ; 
            
            }
            
        private void API_SEND (  SplusExecutionContext __context__, CrestronString CMD ) 
            { 
            short RES = 0;
            
            CrestronString PACKET;
            PACKET  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 512, this );
            
            
            __context__.SourceCodeLine = 386;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt (G_SOCKETSTATUS != 2))  ) ) 
                { 
                __context__.SourceCodeLine = 387;
                return ; 
                } 
            
            __context__.SourceCodeLine = 390;
            MakeString ( PACKET , "{0}{1}", CMD , Functions.Chr ( 10 ) ) ; 
            __context__.SourceCodeLine = 391;
            RES = (short) ( Functions.SocketSend( CLIENT , PACKET ) ) ; 
            __context__.SourceCodeLine = 393;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt (RES == 0))  ) ) 
                { 
                __context__.SourceCodeLine = 394;
                Trace( "(API_Send) Sent[{0}]\r\n", CMD ) ; 
                } 
            
            else 
                { 
                __context__.SourceCodeLine = 396;
                Trace( "[ERROR] (API_Send) Unable to communicate with device!\r\n") ; 
                } 
            
            
            }
            
        private void API_SETPOWER (  SplusExecutionContext __context__, CrestronString STATE ) 
            { 
            
            __context__.SourceCodeLine = 402;
            API_SEND (  __context__ , MAKECMD( __context__ , "set_powerstatus" , MAKEKVPAIR( __context__ , "value" , STATE ) )) ; 
            
            }
            
        private void API_LOGIN (  SplusExecutionContext __context__ ) 
            { 
            CrestronString EXTRA;
            EXTRA  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 256, this );
            
            
            __context__.SourceCodeLine = 410;
            MakeString ( EXTRA , "{0},{1}", MAKEKVPAIR (  __context__ , "username", USERNAME ) , MAKEKVPAIR (  __context__ , "password", PASSWORD ) ) ; 
            __context__.SourceCodeLine = 412;
            API_SEND (  __context__ , MAKECMD( __context__ , "login" , EXTRA )) ; 
            
            }
            
        private void API_GETPOWER (  SplusExecutionContext __context__ ) 
            { 
            
            __context__.SourceCodeLine = 417;
            API_SEND (  __context__ , MAKECMD( __context__ , "get_powerstatus" , "" )) ; 
            
            }
            
        private void API_GETOUTPUTSOURCE (  SplusExecutionContext __context__ ) 
            { 
            
            __context__.SourceCodeLine = 423;
            API_SEND (  __context__ , MAKECMD( __context__ , "get_outputsource1" , "" )) ; 
            
            }
            
        private void API_GETOUTPUTVOLUME (  SplusExecutionContext __context__ ) 
            { 
            
            __context__.SourceCodeLine = 428;
            API_SEND (  __context__ , MAKECMD( __context__ , "get_outputvol" , "" )) ; 
            
            }
            
        private void API_GETMUTEOUTPUT (  SplusExecutionContext __context__ ) 
            { 
            
            __context__.SourceCodeLine = 433;
            API_SEND (  __context__ , MAKECMD( __context__ , "get_muteoutput" , "" )) ; 
            
            }
            
        private void API_SETOUTPUTSOURCE (  SplusExecutionContext __context__, ushort OUTPUT , ushort INPUT ) 
            { 
            CrestronString VALUE;
            VALUE  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 256, this );
            
            
            __context__.SourceCodeLine = 440;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt ( (Functions.TestForTrue ( Functions.BoolToInt (OUTPUT == 99) ) || Functions.TestForTrue ( Functions.BoolToInt (INPUT == 99) )) ))  ) ) 
                {
                __context__.SourceCodeLine = 441;
                return ; 
                }
            
            __context__.SourceCodeLine = 443;
            Trace( "(API_SetOutputSource) Output[{0:d}] Input[{1:d}]\r\n", (short)OUTPUT, (short)INPUT) ; 
            __context__.SourceCodeLine = 445;
            MakeString ( VALUE , "[{{{0},{1}}}]", MAKEKVPAIRINT (  __context__ , "index", (ushort)( OUTPUT )) , MAKEKVPAIR (  __context__ , "value", Functions.ItoA( (int)( INPUT ) )) ) ; 
            __context__.SourceCodeLine = 448;
            G_SELECTED_INPUT = (ushort) ( 99 ) ; 
            __context__.SourceCodeLine = 449;
            G_SELECTED_OUTPUT = (ushort) ( 99 ) ; 
            __context__.SourceCodeLine = 451;
            API_SEND (  __context__ , MAKECMD( __context__ , "set_outputsource1" , MAKEKVPAIRNOQUOTES( __context__ , "value" , VALUE ) )) ; 
            
            }
            
        private void API_SETOUTPUTVOLUME (  SplusExecutionContext __context__, ushort OUTPUT , short LEVEL ) 
            { 
            CrestronString VALUE;
            VALUE  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 256, this );
            
            CrestronString VOLUME;
            VOLUME  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 16, this );
            
            
            __context__.SourceCodeLine = 459;
            MakeString ( VOLUME , "{0:d}", (short)LEVEL) ; 
            __context__.SourceCodeLine = 461;
            MakeString ( VALUE , "[{{{0},{1}}}]", MAKEKVPAIRINT (  __context__ , "index", (ushort)( OUTPUT )) , MAKEKVPAIR (  __context__ , "value", VOLUME) ) ; 
            __context__.SourceCodeLine = 463;
            API_SEND (  __context__ , MAKECMD( __context__ , "set_outputvol" , MAKEKVPAIRNOQUOTES( __context__ , "value" , VALUE ) )) ; 
            
            }
            
        private void API_OUTPUTVOLUMEUP (  SplusExecutionContext __context__, ushort OUTPUT ) 
            { 
            CrestronString VALUE;
            VALUE  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 256, this );
            
            
            __context__.SourceCodeLine = 469;
            MakeString ( VALUE , "[{{{0},{1}}}]", MAKEKVPAIRINT (  __context__ , "index", (ushort)( OUTPUT )) , MAKEKVPAIR (  __context__ , "value", "vol_up") ) ; 
            __context__.SourceCodeLine = 471;
            API_SEND (  __context__ , MAKECMD( __context__ , "set_outputvolsign" , MAKEKVPAIRNOQUOTES( __context__ , "value" , VALUE ) )) ; 
            
            }
            
        private void API_OUTPUTVOLUMEDOWN (  SplusExecutionContext __context__, ushort OUTPUT ) 
            { 
            CrestronString VALUE;
            VALUE  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 256, this );
            
            
            __context__.SourceCodeLine = 477;
            MakeString ( VALUE , "[{{{0},{1}}}]", MAKEKVPAIRINT (  __context__ , "index", (ushort)( OUTPUT )) , MAKEKVPAIR (  __context__ , "value", "vol_down") ) ; 
            __context__.SourceCodeLine = 479;
            API_SEND (  __context__ , MAKECMD( __context__ , "set_outputvolsign" , MAKEKVPAIRNOQUOTES( __context__ , "value" , VALUE ) )) ; 
            
            }
            
        private void API_TOGGLEOUTPUTMUTE (  SplusExecutionContext __context__, ushort OUTPUT ) 
            { 
            CrestronString VALUE;
            VALUE  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 256, this );
            
            CrestronString MUTE;
            MUTE  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 2, this );
            
            
            __context__.SourceCodeLine = 490;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt (G_OUTPUT_MUTE[ OUTPUT ] == 0))  ) ) 
                { 
                __context__.SourceCodeLine = 491;
                MUTE  .UpdateValue ( "1"  ) ; 
                __context__.SourceCodeLine = 492;
                G_OUTPUT_MUTE [ OUTPUT] = (ushort) ( 1 ) ; 
                } 
            
            else 
                { 
                __context__.SourceCodeLine = 494;
                MUTE  .UpdateValue ( "0"  ) ; 
                __context__.SourceCodeLine = 495;
                G_OUTPUT_MUTE [ OUTPUT] = (ushort) ( 0 ) ; 
                } 
            
            __context__.SourceCodeLine = 498;
            MakeString ( VALUE , "[{{{0},{1}}}]", MAKEKVPAIRINT (  __context__ , "index", (ushort)( OUTPUT )) , MAKEKVPAIR (  __context__ , "value", MUTE) ) ; 
            __context__.SourceCodeLine = 500;
            API_SEND (  __context__ , MAKECMD( __context__ , "set_muteoutput" , MAKEKVPAIRNOQUOTES( __context__ , "value" , VALUE ) )) ; 
            
            }
            
        private void API_INIT (  SplusExecutionContext __context__ ) 
            { 
            
            __context__.SourceCodeLine = 505;
            Trace( "(API_Init)\r\n") ; 
            __context__.SourceCodeLine = 507;
            API_GETPOWER (  __context__  ) ; 
            __context__.SourceCodeLine = 508;
            API_GETOUTPUTSOURCE (  __context__  ) ; 
            __context__.SourceCodeLine = 509;
            API_GETOUTPUTVOLUME (  __context__  ) ; 
            __context__.SourceCodeLine = 510;
            API_GETMUTEOUTPUT (  __context__  ) ; 
            
            }
            
        private void API_PARSE_LOGIN (  SplusExecutionContext __context__, CrestronString DATA ) 
            { 
            ushort STATUS = 0;
            
            
            __context__.SourceCodeLine = 519;
            STATUS = (ushort) ( GETINT( __context__ , DATA , "status" ) ) ; 
            __context__.SourceCodeLine = 521;
            Trace( "(API_Parse_Login) Status[{0:d}]\r\n", (short)STATUS) ; 
            __context__.SourceCodeLine = 523;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt (STATUS == 200))  ) ) 
                { 
                __context__.SourceCodeLine = 524;
                Trace( "Successfully logged in!\r\n") ; 
                __context__.SourceCodeLine = 525;
                API_INIT (  __context__  ) ; 
                } 
            
            else 
                { 
                __context__.SourceCodeLine = 527;
                Trace( "Failed to login! Please double check username and password!\r\n") ; 
                } 
            
            
            }
            
        private void API_PARSE_SOURCES (  SplusExecutionContext __context__, CrestronString DATA ) 
            { 
            ushort COUNT = 0;
            
            ushort X = 0;
            
            ushort INDEX = 0;
            
            ushort V = 0;
            
            CrestronString VALUE;
            VALUE  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 1024, this );
            
            CrestronString ITEM;
            ITEM  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 256, this );
            
            
            __context__.SourceCodeLine = 542;
            VALUE  .UpdateValue ( GETOBJECT (  __context__ , DATA, "value")  ) ; 
            __context__.SourceCodeLine = 543;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt ( Functions.Length( VALUE ) < 1 ))  ) ) 
                {
                __context__.SourceCodeLine = 544;
                return ; 
                }
            
            __context__.SourceCodeLine = 546;
            COUNT = (ushort) ( GETARRAYCOUNT( __context__ , VALUE ) ) ; 
            __context__.SourceCodeLine = 547;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt ( COUNT < 1 ))  ) ) 
                {
                __context__.SourceCodeLine = 548;
                return ; 
                }
            
            __context__.SourceCodeLine = 550;
            ushort __FN_FORSTART_VAL__1 = (ushort) ( 1 ) ;
            ushort __FN_FOREND_VAL__1 = (ushort)COUNT; 
            int __FN_FORSTEP_VAL__1 = (int)1; 
            for ( X  = __FN_FORSTART_VAL__1; (__FN_FORSTEP_VAL__1 > 0)  ? ( (X  >= __FN_FORSTART_VAL__1) && (X  <= __FN_FOREND_VAL__1) ) : ( (X  <= __FN_FORSTART_VAL__1) && (X  >= __FN_FOREND_VAL__1) ) ; X  += (ushort)__FN_FORSTEP_VAL__1) 
                { 
                __context__.SourceCodeLine = 551;
                ITEM  .UpdateValue ( GETARRAYITEM (  __context__ , VALUE, (ushort)( X ))  ) ; 
                __context__.SourceCodeLine = 552;
                if ( Functions.TestForTrue  ( ( Functions.BoolToInt ( Functions.Length( ITEM ) < 1 ))  ) ) 
                    {
                    __context__.SourceCodeLine = 553;
                    return ; 
                    }
                
                __context__.SourceCodeLine = 555;
                INDEX = (ushort) ( (GETINT( __context__ , ITEM , "index" ) + 1) ) ; 
                __context__.SourceCodeLine = 556;
                if ( Functions.TestForTrue  ( ( Functions.BoolToInt ( INDEX < 1 ))  ) ) 
                    {
                    __context__.SourceCodeLine = 557;
                    return ; 
                    }
                
                __context__.SourceCodeLine = 559;
                V = (ushort) ( Functions.Atoi( GETVALUE( __context__ , ITEM , "value" ) ) ) ; 
                __context__.SourceCodeLine = 560;
                if ( Functions.TestForTrue  ( ( Functions.BoolToInt ( (Functions.TestForTrue ( Functions.BoolToInt ( V < 1 ) ) || Functions.TestForTrue ( Functions.BoolToInt ( V > 16 ) )) ))  ) ) 
                    {
                    __context__.SourceCodeLine = 561;
                    return ; 
                    }
                
                __context__.SourceCodeLine = 563;
                OUTPUT_SOURCE [ INDEX]  .Value = (ushort) ( V ) ; 
                __context__.SourceCodeLine = 550;
                } 
            
            
            }
            
        private void API_PARSE_VOLUME (  SplusExecutionContext __context__, CrestronString DATA ) 
            { 
            ushort COUNT = 0;
            
            ushort X = 0;
            
            ushort INDEX = 0;
            
            short V = 0;
            
            CrestronString VALUE;
            VALUE  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 1024, this );
            
            CrestronString ITEM;
            ITEM  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 256, this );
            
            
            __context__.SourceCodeLine = 578;
            VALUE  .UpdateValue ( GETOBJECT (  __context__ , DATA, "value")  ) ; 
            __context__.SourceCodeLine = 579;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt ( Functions.Length( VALUE ) < 1 ))  ) ) 
                {
                __context__.SourceCodeLine = 580;
                return ; 
                }
            
            __context__.SourceCodeLine = 582;
            COUNT = (ushort) ( GETARRAYCOUNT( __context__ , VALUE ) ) ; 
            __context__.SourceCodeLine = 583;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt ( COUNT < 1 ))  ) ) 
                {
                __context__.SourceCodeLine = 584;
                return ; 
                }
            
            __context__.SourceCodeLine = 586;
            ushort __FN_FORSTART_VAL__1 = (ushort) ( 1 ) ;
            ushort __FN_FOREND_VAL__1 = (ushort)COUNT; 
            int __FN_FORSTEP_VAL__1 = (int)1; 
            for ( X  = __FN_FORSTART_VAL__1; (__FN_FORSTEP_VAL__1 > 0)  ? ( (X  >= __FN_FORSTART_VAL__1) && (X  <= __FN_FOREND_VAL__1) ) : ( (X  <= __FN_FORSTART_VAL__1) && (X  >= __FN_FOREND_VAL__1) ) ; X  += (ushort)__FN_FORSTEP_VAL__1) 
                { 
                __context__.SourceCodeLine = 587;
                ITEM  .UpdateValue ( GETARRAYITEM (  __context__ , VALUE, (ushort)( X ))  ) ; 
                __context__.SourceCodeLine = 588;
                if ( Functions.TestForTrue  ( ( Functions.BoolToInt ( Functions.Length( ITEM ) < 1 ))  ) ) 
                    {
                    __context__.SourceCodeLine = 589;
                    return ; 
                    }
                
                __context__.SourceCodeLine = 591;
                INDEX = (ushort) ( (GETINT( __context__ , ITEM , "index" ) + 1) ) ; 
                __context__.SourceCodeLine = 592;
                if ( Functions.TestForTrue  ( ( Functions.BoolToInt ( INDEX < 1 ))  ) ) 
                    {
                    __context__.SourceCodeLine = 593;
                    return ; 
                    }
                
                __context__.SourceCodeLine = 595;
                V = (short) ( Functions.Atoi( GETVALUE( __context__ , ITEM , "value" ) ) ) ; 
                __context__.SourceCodeLine = 597;
                OUTPUT_VOLUME [ INDEX]  .Value = (ushort) ( V ) ; 
                __context__.SourceCodeLine = 586;
                } 
            
            
            }
            
        private void API_PARSE_MUTE (  SplusExecutionContext __context__, CrestronString DATA ) 
            { 
            ushort COUNT = 0;
            
            ushort X = 0;
            
            ushort INDEX = 0;
            
            short V = 0;
            
            CrestronString VALUE;
            VALUE  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 1024, this );
            
            CrestronString ITEM;
            ITEM  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 256, this );
            
            
            __context__.SourceCodeLine = 612;
            VALUE  .UpdateValue ( GETOBJECT (  __context__ , DATA, "value")  ) ; 
            __context__.SourceCodeLine = 613;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt ( Functions.Length( VALUE ) < 1 ))  ) ) 
                {
                __context__.SourceCodeLine = 614;
                return ; 
                }
            
            __context__.SourceCodeLine = 616;
            COUNT = (ushort) ( GETARRAYCOUNT( __context__ , VALUE ) ) ; 
            __context__.SourceCodeLine = 617;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt ( COUNT < 1 ))  ) ) 
                {
                __context__.SourceCodeLine = 618;
                return ; 
                }
            
            __context__.SourceCodeLine = 620;
            ushort __FN_FORSTART_VAL__1 = (ushort) ( 1 ) ;
            ushort __FN_FOREND_VAL__1 = (ushort)COUNT; 
            int __FN_FORSTEP_VAL__1 = (int)1; 
            for ( X  = __FN_FORSTART_VAL__1; (__FN_FORSTEP_VAL__1 > 0)  ? ( (X  >= __FN_FORSTART_VAL__1) && (X  <= __FN_FOREND_VAL__1) ) : ( (X  <= __FN_FORSTART_VAL__1) && (X  >= __FN_FOREND_VAL__1) ) ; X  += (ushort)__FN_FORSTEP_VAL__1) 
                { 
                __context__.SourceCodeLine = 621;
                ITEM  .UpdateValue ( GETARRAYITEM (  __context__ , VALUE, (ushort)( X ))  ) ; 
                __context__.SourceCodeLine = 622;
                if ( Functions.TestForTrue  ( ( Functions.BoolToInt ( Functions.Length( ITEM ) < 1 ))  ) ) 
                    {
                    __context__.SourceCodeLine = 623;
                    return ; 
                    }
                
                __context__.SourceCodeLine = 625;
                INDEX = (ushort) ( GETINT( __context__ , ITEM , "index" ) ) ; 
                __context__.SourceCodeLine = 626;
                if ( Functions.TestForTrue  ( ( Functions.BoolToInt ( INDEX > 16 ))  ) ) 
                    {
                    __context__.SourceCodeLine = 627;
                    return ; 
                    }
                
                __context__.SourceCodeLine = 629;
                V = (short) ( Functions.Atoi( GETVALUE( __context__ , ITEM , "value" ) ) ) ; 
                __context__.SourceCodeLine = 630;
                if ( Functions.TestForTrue  ( ( Functions.BoolToInt ( (Functions.TestForTrue ( Functions.BoolToInt (V != 0) ) && Functions.TestForTrue ( Functions.BoolToInt (V != 1) )) ))  ) ) 
                    {
                    __context__.SourceCodeLine = 631;
                    return ; 
                    }
                
                __context__.SourceCodeLine = 633;
                G_OUTPUT_MUTE [ INDEX] = (ushort) ( V ) ; 
                __context__.SourceCodeLine = 620;
                } 
            
            
            }
            
        private void API_PARSE_POWER (  SplusExecutionContext __context__, CrestronString DATA ) 
            { 
            CrestronString STATUS;
            STATUS  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 1024, this );
            
            
            __context__.SourceCodeLine = 641;
            STATUS  .UpdateValue ( GETVALUE (  __context__ , DATA, "value")  ) ; 
            __context__.SourceCodeLine = 643;
            Trace( "(API_Parse_Power) Value[{0}]\r\n", STATUS ) ; 
            __context__.SourceCodeLine = 645;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt (STATUS == "1"))  ) ) 
                { 
                __context__.SourceCodeLine = 646;
                Trace( "(API_Parse_Power) Power On\r\n") ; 
                } 
            
            else 
                { 
                __context__.SourceCodeLine = 648;
                Trace( "(API_Parse_Power) Power Off\r\n") ; 
                } 
            
            __context__.SourceCodeLine = 651;
            POWER_STATE  .Value = (ushort) ( Functions.Atoi( STATUS ) ) ; 
            
            }
            
        private void API_PARSERECEIVED (  SplusExecutionContext __context__, CrestronString DATA ) 
            { 
            CrestronString TYPE;
            TYPE  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 32, this );
            
            ushort STATUS = 0;
            
            
            __context__.SourceCodeLine = 660;
            TYPE  .UpdateValue ( GETVALUE (  __context__ , DATA, "type")  ) ; 
            __context__.SourceCodeLine = 661;
            STATUS = (ushort) ( GETINT( __context__ , DATA , "status" ) ) ; 
            __context__.SourceCodeLine = 665;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt (STATUS == 402))  ) ) 
                { 
                __context__.SourceCodeLine = 666;
                Trace( "(API_ParseReceived) Unauthorized, attempting to login.") ; 
                __context__.SourceCodeLine = 667;
                API_LOGIN (  __context__  ) ; 
                __context__.SourceCodeLine = 668;
                return ; 
                } 
            
            __context__.SourceCodeLine = 671;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt (TYPE == "login"))  ) ) 
                { 
                __context__.SourceCodeLine = 672;
                API_PARSE_LOGIN (  __context__ , DATA) ; 
                } 
            
            else 
                {
                __context__.SourceCodeLine = 673;
                if ( Functions.TestForTrue  ( ( Functions.BoolToInt (TYPE == "get_outputsource1"))  ) ) 
                    { 
                    __context__.SourceCodeLine = 674;
                    API_PARSE_SOURCES (  __context__ , DATA) ; 
                    } 
                
                else 
                    {
                    __context__.SourceCodeLine = 675;
                    if ( Functions.TestForTrue  ( ( Functions.BoolToInt (TYPE == "get_outputvol"))  ) ) 
                        { 
                        __context__.SourceCodeLine = 676;
                        API_PARSE_VOLUME (  __context__ , DATA) ; 
                        } 
                    
                    else 
                        {
                        __context__.SourceCodeLine = 677;
                        if ( Functions.TestForTrue  ( ( Functions.BoolToInt (TYPE == "get_muteoutput"))  ) ) 
                            { 
                            __context__.SourceCodeLine = 678;
                            API_PARSE_MUTE (  __context__ , DATA) ; 
                            } 
                        
                        else 
                            {
                            __context__.SourceCodeLine = 679;
                            if ( Functions.TestForTrue  ( ( Functions.BoolToInt (TYPE == "get_powerstatus"))  ) ) 
                                { 
                                __context__.SourceCodeLine = 680;
                                API_PARSE_POWER (  __context__ , DATA) ; 
                                } 
                            
                            else 
                                {
                                __context__.SourceCodeLine = 681;
                                if ( Functions.TestForTrue  ( ( Functions.BoolToInt (TYPE == "set_muteoutput"))  ) ) 
                                    { 
                                    } 
                                
                                else 
                                    {
                                    __context__.SourceCodeLine = 683;
                                    if ( Functions.TestForTrue  ( ( Functions.BoolToInt (TYPE == "set_outputsource1"))  ) ) 
                                        { 
                                        } 
                                    
                                    else 
                                        {
                                        __context__.SourceCodeLine = 685;
                                        if ( Functions.TestForTrue  ( ( Functions.BoolToInt (TYPE == "set_outputvol"))  ) ) 
                                            { 
                                            } 
                                        
                                        else 
                                            { 
                                            __context__.SourceCodeLine = 688;
                                            Trace( "(API_ParseReceived) Unknown Type!\r\n") ; 
                                            } 
                                        
                                        }
                                    
                                    }
                                
                                }
                            
                            }
                        
                        }
                    
                    }
                
                }
            
            
            }
            
        object POWER_ON_OnPush_0 ( Object __EventInfo__ )
        
            { 
            Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
            try
            {
                SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
                
                __context__.SourceCodeLine = 699;
                Trace( "(POWER_ON)\r\n") ; 
                __context__.SourceCodeLine = 701;
                API_SETPOWER (  __context__ , "1") ; 
                
                
            }
            catch(Exception e) { ObjectCatchHandler(e); }
            finally { ObjectFinallyHandler( __SignalEventArg__ ); }
            return this;
            
        }
        
    object POWER_OFF_OnPush_1 ( Object __EventInfo__ )
    
        { 
        Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
        try
        {
            SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
            
            __context__.SourceCodeLine = 707;
            Trace( "(POWER_OFF)\r\n") ; 
            __context__.SourceCodeLine = 709;
            API_SETPOWER (  __context__ , "0") ; 
            
            
        }
        catch(Exception e) { ObjectCatchHandler(e); }
        finally { ObjectFinallyHandler( __SignalEventArg__ ); }
        return this;
        
    }
    
object OUTPUT_VOLUME_UP_OnPush_2 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        ushort I = 0;
        
        
        __context__.SourceCodeLine = 716;
        I = (ushort) ( Functions.GetLastModifiedArrayIndex( __SignalEventArg__ ) ) ; 
        __context__.SourceCodeLine = 718;
        Trace( "(OUTPUT_VOLUME_UP) [{0:d}]\r\n", (short)I) ; 
        __context__.SourceCodeLine = 720;
        API_OUTPUTVOLUMEDOWN (  __context__ , (ushort)( (I - 1) )) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object OUTPUT_VOLUME_UP_OnRelease_3 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        
        __context__.SourceCodeLine = 725;
        API_GETOUTPUTVOLUME (  __context__  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object OUTPUT_VOLUME_DOWN_OnPush_4 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        ushort I = 0;
        
        
        __context__.SourceCodeLine = 731;
        I = (ushort) ( Functions.GetLastModifiedArrayIndex( __SignalEventArg__ ) ) ; 
        __context__.SourceCodeLine = 733;
        Trace( "(OUTPUT_VOLUME_DOWN) [{0:d}]\r\n", (short)I) ; 
        __context__.SourceCodeLine = 735;
        API_OUTPUTVOLUMEUP (  __context__ , (ushort)( (I - 1) )) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object OUTPUT_VOLUME_DOWN_OnRelease_5 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        
        __context__.SourceCodeLine = 740;
        API_GETOUTPUTVOLUME (  __context__  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object MUTE_OUTPUT_OnPush_6 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        ushort I = 0;
        
        
        __context__.SourceCodeLine = 747;
        I = (ushort) ( Functions.GetLastModifiedArrayIndex( __SignalEventArg__ ) ) ; 
        __context__.SourceCodeLine = 749;
        Trace( "(MUTE_OUTPUT) [{0:d}]\r\n", (short)I) ; 
        __context__.SourceCodeLine = 751;
        API_TOGGLEOUTPUTMUTE (  __context__ , (ushort)( (I - 1) )) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object SELECT_OUTPUT_OnPush_7 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        ushort I = 0;
        
        
        __context__.SourceCodeLine = 757;
        I = (ushort) ( Functions.GetLastModifiedArrayIndex( __SignalEventArg__ ) ) ; 
        __context__.SourceCodeLine = 759;
        Trace( "(SELECT_OUTPUT) [{0:d}]\r\n", (short)I) ; 
        __context__.SourceCodeLine = 761;
        G_SELECTED_OUTPUT = (ushort) ( (I - 1) ) ; 
        __context__.SourceCodeLine = 763;
        API_SETOUTPUTSOURCE (  __context__ , (ushort)( G_SELECTED_OUTPUT ), (ushort)( G_SELECTED_INPUT )) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object SELECT_INPUT_OnPush_8 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        ushort I = 0;
        
        
        __context__.SourceCodeLine = 769;
        I = (ushort) ( Functions.GetLastModifiedArrayIndex( __SignalEventArg__ ) ) ; 
        __context__.SourceCodeLine = 771;
        Trace( "(SELECT_INPUT) [{0:d}]\r\n", (short)I) ; 
        __context__.SourceCodeLine = 773;
        G_SELECTED_INPUT = (ushort) ( (I - 1) ) ; 
        __context__.SourceCodeLine = 775;
        API_SETOUTPUTSOURCE (  __context__ , (ushort)( G_SELECTED_OUTPUT ), (ushort)( G_SELECTED_INPUT )) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object SET_OUTPUT_VOLUME_OnChange_9 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        short V = 0;
        
        ushort I = 0;
        
        
        __context__.SourceCodeLine = 782;
        I = (ushort) ( Functions.GetLastModifiedArrayIndex( __SignalEventArg__ ) ) ; 
        __context__.SourceCodeLine = 784;
        Trace( "(SET_OUTPUT_VOLUME) [{0:d}] - {1:d}\r\n", (short)I, (short)SET_OUTPUT_VOLUME[ I ] .UshortValue) ; 
        __context__.SourceCodeLine = 786;
        V = (short) ( SET_OUTPUT_VOLUME[ I ] .ShortValue ) ; 
        __context__.SourceCodeLine = 788;
        API_SETOUTPUTVOLUME (  __context__ , (ushort)( (I - 1) ), (short)( V )) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object CLIENT_OnSocketConnect_10 ( Object __Info__ )

    { 
    SocketEventInfo __SocketInfo__ = (SocketEventInfo)__Info__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SocketInfo__);
        
        __context__.SourceCodeLine = 793;
        Trace( "(SOCKETCONNECT)\r\n") ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SocketInfo__ ); }
    return this;
    
}

object CLIENT_OnSocketDisconnect_11 ( Object __Info__ )

    { 
    SocketEventInfo __SocketInfo__ = (SocketEventInfo)__Info__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SocketInfo__);
        
        __context__.SourceCodeLine = 798;
        Trace( "(SOCKETDISCONNECT)\r\n") ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SocketInfo__ ); }
    return this;
    
}

object CLIENT_OnSocketReceive_12 ( Object __Info__ )

    { 
    SocketEventInfo __SocketInfo__ = (SocketEventInfo)__Info__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SocketInfo__);
        CrestronString RECEIVEDDATA;
        RECEIVEDDATA  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 10240, this );
        
        
        __context__.SourceCodeLine = 805;
        RECEIVEDDATA  .UpdateValue ( CLIENT .  SocketRxBuf  ) ; 
        __context__.SourceCodeLine = 807;
        Functions.ClearBuffer ( CLIENT .  SocketRxBuf ) ; 
        __context__.SourceCodeLine = 809;
        Trace( "(SOCKETRECEIVE): Data Received: {0}\r\n", RECEIVEDDATA ) ; 
        __context__.SourceCodeLine = 811;
        API_PARSERECEIVED (  __context__ , RECEIVEDDATA) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SocketInfo__ ); }
    return this;
    
}

object CLIENT_OnSocketStatus_13 ( Object __Info__ )

    { 
    SocketEventInfo __SocketInfo__ = (SocketEventInfo)__Info__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SocketInfo__);
        ushort STATUS = 0;
        
        
        __context__.SourceCodeLine = 818;
        STATUS = (ushort) ( __SocketInfo__.SocketStatus ) ; 
        __context__.SourceCodeLine = 820;
        Trace( "(SOCKETSTATUS): Status: {0}\r\n", GETSOCKETERROR (  __context__ , (ushort)( STATUS )) ) ; 
        __context__.SourceCodeLine = 822;
        if ( Functions.TestForTrue  ( ( Functions.BoolToInt (STATUS != G_SOCKETSTATUS))  ) ) 
            { 
            __context__.SourceCodeLine = 823;
            G_SOCKETSTATUS = (short) ( STATUS ) ; 
            __context__.SourceCodeLine = 825;
            if ( Functions.TestForTrue  ( ( Functions.BoolToInt (G_SOCKETSTATUS == 2))  ) ) 
                { 
                __context__.SourceCodeLine = 826;
                API_LOGIN (  __context__  ) ; 
                } 
            
            } 
        
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SocketInfo__ ); }
    return this;
    
}

public override object FunctionMain (  object __obj__ ) 
    { 
    try
    {
        SplusExecutionContext __context__ = SplusFunctionMainStartCode();
        
        __context__.SourceCodeLine = 842;
        G_SELECTED_OUTPUT = (ushort) ( 99 ) ; 
        __context__.SourceCodeLine = 843;
        G_SELECTED_INPUT = (ushort) ( 99 ) ; 
        __context__.SourceCodeLine = 845;
        WaitForInitializationComplete ( ) ; 
        __context__.SourceCodeLine = 852;
        G_CONNECTIONSTATUS = (short) ( Functions.SocketConnectClient( CLIENT , IP_ADDRESS  , (ushort)( 8080 ) , (ushort)( 1 ) ) ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler(); }
    return __obj__;
    }
    

public override void LogosSplusInitialize()
{
    SocketInfo __socketinfo__ = new SocketInfo( 1, this );
    InitialParametersClass.ResolveHostName = __socketinfo__.ResolveHostName;
    _SplusNVRAM = new SplusNVRAM( this );
    G_OUTPUT_MUTE  = new ushort[ 17 ];
    CLIENT  = new SplusTcpClient ( 10240, this );
    
    POWER_ON = new Crestron.Logos.SplusObjects.DigitalInput( POWER_ON__DigitalInput__, this );
    m_DigitalInputList.Add( POWER_ON__DigitalInput__, POWER_ON );
    
    POWER_OFF = new Crestron.Logos.SplusObjects.DigitalInput( POWER_OFF__DigitalInput__, this );
    m_DigitalInputList.Add( POWER_OFF__DigitalInput__, POWER_OFF );
    
    SELECT_OUTPUT = new InOutArray<DigitalInput>( 16, this );
    for( uint i = 0; i < 16; i++ )
    {
        SELECT_OUTPUT[i+1] = new Crestron.Logos.SplusObjects.DigitalInput( SELECT_OUTPUT__DigitalInput__ + i, SELECT_OUTPUT__DigitalInput__, this );
        m_DigitalInputList.Add( SELECT_OUTPUT__DigitalInput__ + i, SELECT_OUTPUT[i+1] );
    }
    
    SELECT_INPUT = new InOutArray<DigitalInput>( 16, this );
    for( uint i = 0; i < 16; i++ )
    {
        SELECT_INPUT[i+1] = new Crestron.Logos.SplusObjects.DigitalInput( SELECT_INPUT__DigitalInput__ + i, SELECT_INPUT__DigitalInput__, this );
        m_DigitalInputList.Add( SELECT_INPUT__DigitalInput__ + i, SELECT_INPUT[i+1] );
    }
    
    OUTPUT_VOLUME_UP = new InOutArray<DigitalInput>( 16, this );
    for( uint i = 0; i < 16; i++ )
    {
        OUTPUT_VOLUME_UP[i+1] = new Crestron.Logos.SplusObjects.DigitalInput( OUTPUT_VOLUME_UP__DigitalInput__ + i, OUTPUT_VOLUME_UP__DigitalInput__, this );
        m_DigitalInputList.Add( OUTPUT_VOLUME_UP__DigitalInput__ + i, OUTPUT_VOLUME_UP[i+1] );
    }
    
    OUTPUT_VOLUME_DOWN = new InOutArray<DigitalInput>( 16, this );
    for( uint i = 0; i < 16; i++ )
    {
        OUTPUT_VOLUME_DOWN[i+1] = new Crestron.Logos.SplusObjects.DigitalInput( OUTPUT_VOLUME_DOWN__DigitalInput__ + i, OUTPUT_VOLUME_DOWN__DigitalInput__, this );
        m_DigitalInputList.Add( OUTPUT_VOLUME_DOWN__DigitalInput__ + i, OUTPUT_VOLUME_DOWN[i+1] );
    }
    
    MUTE_OUTPUT = new InOutArray<DigitalInput>( 16, this );
    for( uint i = 0; i < 16; i++ )
    {
        MUTE_OUTPUT[i+1] = new Crestron.Logos.SplusObjects.DigitalInput( MUTE_OUTPUT__DigitalInput__ + i, MUTE_OUTPUT__DigitalInput__, this );
        m_DigitalInputList.Add( MUTE_OUTPUT__DigitalInput__ + i, MUTE_OUTPUT[i+1] );
    }
    
    POWER_STATE = new Crestron.Logos.SplusObjects.DigitalOutput( POWER_STATE__DigitalOutput__, this );
    m_DigitalOutputList.Add( POWER_STATE__DigitalOutput__, POWER_STATE );
    
    SET_OUTPUT_VOLUME = new InOutArray<AnalogInput>( 16, this );
    for( uint i = 0; i < 16; i++ )
    {
        SET_OUTPUT_VOLUME[i+1] = new Crestron.Logos.SplusObjects.AnalogInput( SET_OUTPUT_VOLUME__AnalogSerialInput__ + i, SET_OUTPUT_VOLUME__AnalogSerialInput__, this );
        m_AnalogInputList.Add( SET_OUTPUT_VOLUME__AnalogSerialInput__ + i, SET_OUTPUT_VOLUME[i+1] );
    }
    
    OUTPUT_SOURCE = new InOutArray<AnalogOutput>( 16, this );
    for( uint i = 0; i < 16; i++ )
    {
        OUTPUT_SOURCE[i+1] = new Crestron.Logos.SplusObjects.AnalogOutput( OUTPUT_SOURCE__AnalogSerialOutput__ + i, this );
        m_AnalogOutputList.Add( OUTPUT_SOURCE__AnalogSerialOutput__ + i, OUTPUT_SOURCE[i+1] );
    }
    
    OUTPUT_VOLUME = new InOutArray<AnalogOutput>( 16, this );
    for( uint i = 0; i < 16; i++ )
    {
        OUTPUT_VOLUME[i+1] = new Crestron.Logos.SplusObjects.AnalogOutput( OUTPUT_VOLUME__AnalogSerialOutput__ + i, this );
        m_AnalogOutputList.Add( OUTPUT_VOLUME__AnalogSerialOutput__ + i, OUTPUT_VOLUME[i+1] );
    }
    
    IP_ADDRESS = new StringParameter( IP_ADDRESS__Parameter__, this );
    m_ParameterList.Add( IP_ADDRESS__Parameter__, IP_ADDRESS );
    
    USERNAME = new StringParameter( USERNAME__Parameter__, this );
    m_ParameterList.Add( USERNAME__Parameter__, USERNAME );
    
    PASSWORD = new StringParameter( PASSWORD__Parameter__, this );
    m_ParameterList.Add( PASSWORD__Parameter__, PASSWORD );
    
    
    POWER_ON.OnDigitalPush.Add( new InputChangeHandlerWrapper( POWER_ON_OnPush_0, false ) );
    POWER_OFF.OnDigitalPush.Add( new InputChangeHandlerWrapper( POWER_OFF_OnPush_1, false ) );
    for( uint i = 0; i < 16; i++ )
        OUTPUT_VOLUME_UP[i+1].OnDigitalPush.Add( new InputChangeHandlerWrapper( OUTPUT_VOLUME_UP_OnPush_2, false ) );
        
    for( uint i = 0; i < 16; i++ )
        OUTPUT_VOLUME_UP[i+1].OnDigitalRelease.Add( new InputChangeHandlerWrapper( OUTPUT_VOLUME_UP_OnRelease_3, false ) );
        
    for( uint i = 0; i < 16; i++ )
        OUTPUT_VOLUME_DOWN[i+1].OnDigitalPush.Add( new InputChangeHandlerWrapper( OUTPUT_VOLUME_DOWN_OnPush_4, false ) );
        
    for( uint i = 0; i < 16; i++ )
        OUTPUT_VOLUME_DOWN[i+1].OnDigitalRelease.Add( new InputChangeHandlerWrapper( OUTPUT_VOLUME_DOWN_OnRelease_5, false ) );
        
    for( uint i = 0; i < 16; i++ )
        MUTE_OUTPUT[i+1].OnDigitalPush.Add( new InputChangeHandlerWrapper( MUTE_OUTPUT_OnPush_6, false ) );
        
    for( uint i = 0; i < 16; i++ )
        SELECT_OUTPUT[i+1].OnDigitalPush.Add( new InputChangeHandlerWrapper( SELECT_OUTPUT_OnPush_7, false ) );
        
    for( uint i = 0; i < 16; i++ )
        SELECT_INPUT[i+1].OnDigitalPush.Add( new InputChangeHandlerWrapper( SELECT_INPUT_OnPush_8, false ) );
        
    for( uint i = 0; i < 16; i++ )
        SET_OUTPUT_VOLUME[i+1].OnAnalogChange.Add( new InputChangeHandlerWrapper( SET_OUTPUT_VOLUME_OnChange_9, false ) );
        
    CLIENT.OnSocketConnect.Add( new SocketHandlerWrapper( CLIENT_OnSocketConnect_10, false ) );
    CLIENT.OnSocketDisconnect.Add( new SocketHandlerWrapper( CLIENT_OnSocketDisconnect_11, false ) );
    CLIENT.OnSocketReceive.Add( new SocketHandlerWrapper( CLIENT_OnSocketReceive_12, false ) );
    CLIENT.OnSocketStatus.Add( new SocketHandlerWrapper( CLIENT_OnSocketStatus_13, false ) );
    
    _SplusNVRAM.PopulateCustomAttributeList( true );
    
    NVRAM = _SplusNVRAM;
    
}

public override void LogosSimplSharpInitialize()
{
    
    
}

public UserModuleClass_EPISODE_EA_RSP_V1_2 ( string InstanceName, string ReferenceID, Crestron.Logos.SplusObjects.CrestronStringEncoding nEncodingType ) : base( InstanceName, ReferenceID, nEncodingType ) {}




const uint POWER_ON__DigitalInput__ = 0;
const uint POWER_OFF__DigitalInput__ = 1;
const uint SELECT_OUTPUT__DigitalInput__ = 2;
const uint SELECT_INPUT__DigitalInput__ = 18;
const uint OUTPUT_VOLUME_UP__DigitalInput__ = 34;
const uint OUTPUT_VOLUME_DOWN__DigitalInput__ = 50;
const uint MUTE_OUTPUT__DigitalInput__ = 66;
const uint SET_OUTPUT_VOLUME__AnalogSerialInput__ = 0;
const uint POWER_STATE__DigitalOutput__ = 0;
const uint OUTPUT_SOURCE__AnalogSerialOutput__ = 0;
const uint OUTPUT_VOLUME__AnalogSerialOutput__ = 16;
const uint IP_ADDRESS__Parameter__ = 10;
const uint USERNAME__Parameter__ = 11;
const uint PASSWORD__Parameter__ = 12;

[SplusStructAttribute(-1, true, false)]
public class SplusNVRAM : SplusStructureBase
{

    public SplusNVRAM( SplusObject __caller__ ) : base( __caller__ ) {}
    
    
}

SplusNVRAM _SplusNVRAM = null;

public class __CEvent__ : CEvent
{
    public __CEvent__() {}
    public void Close() { base.Close(); }
    public int Reset() { return base.Reset() ? 1 : 0; }
    public int Set() { return base.Set() ? 1 : 0; }
    public int Wait( int timeOutInMs ) { return base.Wait( timeOutInMs ) ? 1 : 0; }
}
public class __CMutex__ : CMutex
{
    public __CMutex__() {}
    public void Close() { base.Close(); }
    public void ReleaseMutex() { base.ReleaseMutex(); }
    public int WaitForMutex() { return base.WaitForMutex() ? 1 : 0; }
}
 public int IsNull( object obj ){ return (obj == null) ? 1 : 0; }
}


}
